﻿using System;
using Prism.Ioc;
using Borepin.PageModel;
using Borepin.Page;
using Xamarin.Forms;
using Borepin.Service;
using Borepin.Service.Instances;
using Borepin.View;
using Borepin.ViewModel;
using Borepin.Dialog;
using Borepin.DialogModel;

namespace Borepin
{
    public partial class App
    {
        public App()
        {

        }

        protected override async void OnInitialized()
        {
            InitializeComponent();

            //var result = await NavigationService.NavigateAsync("/NavigationPage/HostSelectPage");
            var result = await NavigationService.NavigateAsync("/MainPage/NavigationPage/ServerListPage");
            //var result = await NavigationService.NavigateAsync("/ListPage");

            if (!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterForNavigation<NavigationPage>();
            containerRegistry.RegisterForNavigation<MainPage, MainPagePageModel>();
            containerRegistry.RegisterForNavigation<MachinesPage, MachinesPageModel>();
            containerRegistry.RegisterForNavigation<SettingsPage>();
            containerRegistry.RegisterForNavigation<MachinePage, MachinePageModel>();
            containerRegistry.RegisterForNavigation<LoginPasswordPage, LoginPasswordPageModel>();
            containerRegistry.RegisterForNavigation<HostSelectPage, HostSelectPageModel>();
            containerRegistry.RegisterForNavigation<LoginChoosePage, LoginChoosePageModel>();
            containerRegistry.RegisterForNavigation<ServerListPage, ServerListPageModel>();

            containerRegistry.RegisterForNavigation<ListPage, ListPageModel>();

            containerRegistry.RegisterDialog<ConfirmDialog, ConfirmDialogModel>();
            

            InstanceService bffhInstanceService = new InstanceService();
            containerRegistry.RegisterInstance<IInstanceService>(bffhInstanceService);
            containerRegistry.RegisterInstance<BFFHService>(new BFFHService(bffhInstanceService));

        }
    }
}
